<template>
  <component
    :is="tag || 'div'"
    :class="{ 'Dropdown--HasChanged': hasChanged }"
    class="Dropdown"
  >
    <label v-if="label" :for="uuid + '_select'" class="Dropdown__Label">
      {{ label }}
    </label>
    <!--suppress HtmlFormInputWithoutLabel -->
    <select
      :id="uuid + '_select'"
      :value="modelValue"
      class="Dropdown__Control"
      @input="$emit('update:modelValue', $event.target.value)"
      :disabled="disabled"
    >
      <option v-for="(value, label) in options" :key="label" :value="value">
        {{ noTranslate ? label : t(label) }}
      </option>
    </select>
  </component>
</template>

<script lang="ts">
import { defineComponent, PropType } from 'vue'
import { isControl, ControlEmits } from '@/components/controls/mixins/IsControl'

export default defineComponent({
  name: 'Dropdown',
  emits: [...ControlEmits],
  props: {
    tag: String,
    label: String,
    modelValue: null,
    options: Object as PropType<Record<string, object>>,
    noTranslate: Boolean,
    debounceDelay: Number,
    disabled: Boolean,
  },

  setup(props, context) {
    return {
      ...isControl<unknown>({ props, context }),
    }
  },
})
</script>

<style lang="scss" scoped>
@use '../../style/variables';
@use './mixins/control' as c;

.Dropdown {
  @include c.control;

  border: none;
}
</style>
